Shader "Igloo/Scale" {
    Properties {
        _MainTex ("Texture", 2D) = "white" {}
        _ThetaRange ("Theta Range", Float) = 360.0 
    }
    SubShader {
        Tags { "RenderType"="Opaque" }
        LOD 100

        Pass {
            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            #include "UnityCG.cginc"

            struct appdata {
                float4 vertex : POSITION;
                float2 uv : TEXCOORD0;
            };

            struct v2f {
                float2 uv : TEXCOORD0;
                float4 vertex : SV_POSITION;
            };

            sampler2D _MainTex;
            float4 _MainTex_ST;
            float _ThetaRange;

            v2f vert (appdata v) {
                v2f o;
                o.vertex = UnityObjectToClipPos(v.vertex);

                float scale = 1.0 - (_ThetaRange / 360.0);
                float offset =_ThetaRange / 360.0;

                o.uv = v.uv;
                o.uv.y = (o.uv.y * (1.0 - scale)) + offset; 
                return o;
            }

            fixed4 frag (v2f i) : SV_Target {
                fixed4 col = tex2D(_MainTex, i.uv);
                return col;
            }
            ENDCG
        }
    }
    FallBack "Diffuse"
}
    