Shader "Igloo/SideBySide" {
        Properties{
            _LeftEyeTexture("Left Eye Texture", 2D) = "white" {}
            _RightEyeTexture("Right Eye Texture", 2D) = "white" {}
            _SourceX("Source X position", Range(0, 1)) = 0
            _SourceY("Source Y position", Range(0, 1)) = 0
            _SourceWidth("Source Width", Range(0, 1)) = 1
            _SourceHeight("Source Height", Range(0, 1)) = 1
        }

            SubShader{
                Pass {
                    CGPROGRAM
                    #pragma vertex vert
                    #pragma fragment frag
                    #include "UnityCG.cginc"

                    struct appdata {
                        float4 vertex : POSITION;
                        float2 uv : TEXCOORD0;
                    };

                    struct v2f {
                        float2 uv : TEXCOORD0;
                        float4 vertex : SV_POSITION;
                    };

                    sampler2D _LeftEyeTexture;
                    sampler2D _RightEyeTexture;
                    float _SourceX;
                    float _SourceY;
                    float _SourceWidth;
                    float _SourceHeight;

                    v2f vert(appdata v) {
                        v2f o;
                        o.vertex = UnityObjectToClipPos(v.vertex);
                        o.uv = v.uv;
                        return o;
                    }

                    fixed4 frag(v2f i) : SV_Target {
                        fixed2 sourceUV;

                        if (i.uv.x < 0.5) {
                            sourceUV = float2(_SourceX + (i.uv.x * 2.0 * _SourceWidth), _SourceY + i.uv.y * _SourceHeight);
                            return tex2D(_LeftEyeTexture, sourceUV);
                        }
         else {
          sourceUV = float2(_SourceX + ((i.uv.x - 0.5) * 2.0 * _SourceWidth), _SourceY + i.uv.y * _SourceHeight);
          return tex2D(_RightEyeTexture, sourceUV);
      }
  }
  ENDCG
}
            }
    }
