Shader "Igloo/SubsectionRender" {
    Properties{
        _MainTex("Main Texture", 2D) = "white" {}
        _X("X position", Range(0, 1)) = 0
        _Y("Y position", Range(0, 1)) = 0
        _Width("Width", Range(0, 1)) = 1
        _Height("Height", Range(0, 1)) = 1
        _SourceX("Source X position", Range(0, 1)) = 0
        _SourceY("Source Y position", Range(0, 1)) = 0
        _SourceWidth("Source Width", Range(0, 1)) = 1
        _SourceHeight("Source Height", Range(0, 1)) = 1
    }

        SubShader{
            Tags { "RenderType" = "Opaque" }

            Pass {
                ZTest Always // Added ZTest directive to ensure proper clearing

                CGPROGRAM
                #pragma vertex vert
                #pragma fragment frag
                #include "UnityCG.cginc"

                struct appdata {
                    float4 vertex : POSITION;
                    float2 uv : TEXCOORD0;
                };

                struct v2f {
                    float2 uv : TEXCOORD0;
                    float4 vertex : SV_POSITION;
                };

                sampler2D _MainTex;
                float _X;
                float _Y;
                float _Width;
                float _Height;
                float _SourceX;
                float _SourceY;
                float _SourceWidth;
                float _SourceHeight;

                v2f vert(appdata v) {
                    v2f o;
                    o.vertex = UnityObjectToClipPos(v.vertex);
                    o.uv = v.uv;
                    return o;
                }

                fixed4 frag(v2f i) : SV_Target {
                    float2 destUV = float2((i.uv.x - _X) / _Width, (i.uv.y - _Y) / _Height);

                    destUV = clamp(destUV, 0, 1);

                    float2 sourceUV = float2(_SourceX + destUV.x * _SourceWidth, _SourceY + destUV.y * _SourceHeight);

                    fixed4 color = tex2D(_MainTex, sourceUV);

                    return color;
                }
                ENDCG
            }
        }
}
